program geometry_with_ruler;

{$APPTYPE CONSOLE}
{$r+}

const
  d_max = 1000;
  d_c = 10000;
  pt_max = 1000;

type
  l_num = record
    x: array[0..d_max] of integer;
    l: integer;
    ng: boolean;
  end;
  r_num = record
    a, b: l_num;
  end;
  pt = record
    x, y: r_num;
  end;

var
  x, y, z: l_num;
  zero, minusone: r_num;
  i, j, n, k, cptr, s0, s1, s2, s3: integer;
  xstr, ystr: string;
  a: array[0..pt_max] of pt;
  num, strt: array[0..pt_max] of integer;
  a1, b1, c1, a2, b2, c2, tk1, tk2, tk3, det: r_num;
  inters: pt;
  nw: boolean;

procedure l_pos_add (var apar, bpar, cpar: l_num);
var i, rem: integer;
begin
  i := 1; rem := 0;
  while (i <= apar.l) or (i <= bpar.l) or (rem <> 0) do
  begin
    cpar.x[i] := apar.x[i] + bpar.x[i] + rem;
    rem := cpar.x[i] div d_c;
    cpar.x[i] := cpar.x[i] mod d_c;
    inc(i);
  end;

  cpar.l := i;
  while (cpar.l > 0) and (cpar.x[cpar.l] = 0) do dec(cpar.l);
end;

procedure l_pos_sub (var apar, bpar, cpar: l_num);
var i, rem: integer;
begin
  i := 1; rem := 0;
  while (i <= apar.l) or (i <= bpar.l) or (rem <> 0) do
  begin
    cpar.x[i] := apar.x[i] - bpar.x[i] - rem;
    if cpar.x[i] < 0 then
    begin
      rem := 1;
      cpar.x[i] := d_c - cpar.x[i];
    end
    else rem := 0;
    inc(i);
  end;

  cpar.l := i;
  while cpar.x[cpar.l] = 0 do dec(cpar.l);
end;

procedure l_add (var apar, bpar, cpar: l_num);
begin
  fillchar(cpar, sizeof(cpar), 0);
  if (apar.l = 0) and (bpar.l = 0) then exit;

  if (apar.ng = bpar.ng) then l_pos_add(apar, bpar, cpar)
  else if (not apar.ng) and bpar.ng then l_pos_sub(apar, bpar, cpar)
  else l_pos_sub(bpar, apar, cpar);
end;

procedure cpy (var apar, bpar: l_num);
var i: integer;
begin
  for i := 1 to apar.l do bpar.x[i] := apar.x[i];
  bpar.l := apar.l;
end;

procedure l_mult (var apar, bpar, cpar: l_num);
var
  kl, ml: l_num;
  i, j, rem: integer;
begin
  fillchar(cpar, sizeof(cpar), 0);

  if (apar.l = 0) or (bpar.l = 0) then exit;

  for i := 1 to apar.l do
  begin
    fillchar(kl, sizeof(kl), 0);
    kl.l := bpar.l + i - 1;
    for j := 1 to bpar.l do kl.x[j + i - 1] := bpar.x[j];

    j := 1; rem := 0;
    while (j <= kl.l) or (rem <> 0) do
    begin
      kl.x[j] := kl.x[j]*apar.x[i] + rem;
      rem := kl.x[j] div d_c;
      kl.x[j] := kl.x[j] mod d_c;
      inc(j);
    end;
    kl.l := j;

    l_add(cpar, kl, ml);
    cpy(ml, cpar);
  end;

  cpar.ng := apar.ng <> bpar.ng;
end;

procedure r_add (var apar, bpar, cpar: r_num);
var k1, k2: l_num;
begin
  l_mult(apar.b, bpar.b, cpar.b);
  l_mult(apar.a, bpar.b, k1);
  l_mult(apar.b, bpar.a, k2);
  l_add(k1, k2, cpar.a);
end;

procedure r_sub (var apar, bpar, cpar: r_num);
var tl: r_num;
begin
  tl := bpar;
  tl.a.ng := not (tl.a.ng);
  r_add(apar, tl, cpar);
end;

procedure r_mul(var apar, bpar, cpar: r_num);
begin
  l_mult(apar.a, bpar.a, cpar.a);
  l_mult(apar.b, bpar.b, cpar.b);
end;

procedure r_div(var apar, bpar, cpar: r_num);
begin
  l_mult(apar.a, bpar.b, cpar.a);
  l_mult(apar.b, bpar.a, cpar.b);
end;

function l_eq(var apar, bpar: l_num): boolean;
var i: integer;
begin
  result := true; i := 1;
  while result and ((i <= apar.l) or (i <= bpar.l)) do
  begin
    result := result and (apar.x[i]*ord(apar.ng) = bpar.x[i]*ord(bpar.ng));
    inc(i);
  end;
end;

function r_eq (var apar, bpar: r_num): boolean;
var k1, k2: l_num;
begin
  l_mult(apar.a, bpar.b, k1);
  l_mult(apar.b, bpar.a, k2);
  result := l_eq(k1, k2);
end;

procedure writelong(var apar: l_num);
var i: integer;
begin
  if apar.ng then write('-');
  for i := apar.l downto 1 do write(apar.x[i]);
end;

begin
  assignfile (input, 'input.txt'); reset (input);
  assignfile (output, 'output.txt'); rewrite (output);

  minusone.a.l := 1;
  minusone.a.x[1] := 1;
  minusone.a.ng := true;
  minusone.b.l := 1;
  minusone.b.x[1] := 1;
  minusone.b.ng := false;

  zero.b.l := 1;
  zero.b.x[1] := 1;

  read (n, k); num[1] := n; strt[1] := 1; strt[2] := n + 1;
  for i := 1 to n do
  begin
    read (a[i].x.a.x[1], a[i].y.a.x[1]);
    a[i].x.a.l := 1; a[i].y.a.l := 1;
    a[i].x.b.x[1] := 1; a[i].x.b.l := 1;
    a[i].y.b.x[1] := 1; a[i].y.b.l := 1;
  end;
  inc(k); cptr := n + 1;

  for i := 2 to k do
  begin
    for s0 := strt[i-1] to strt[i-1]+num[i-1]-1 do
      for s1 := 1 to strt[i] do
        for s2 := 1 to strt[i] do
          for s3 := 1 to strt[i] do
          begin

{            a1 := s1.y - s0.y; b1 := s0.x - s1.x;
            a2 := s3.y - s2.y; b2 := s2.x - s3.x;

            c1 := -(a1*s1.x + b1*s1.y);
            c2 := -(a2*s3.x + b2*s3.y);

            det := a1*b2 - b1*a2;

            if det = 0 then continue;

            inters.x := (c1*b2 - c2*b1) / det;
            inters.y := (a1*c2 - a2*c1) / det; }

            r_sub(a[s1].y, a[s0].y, a1);
            r_sub(a[s0].x, a[s1].x, b1);
            r_sub(a[s3].y, a[s2].y, a2);
            r_sub(a[s2].x, a[s3].x, b2);

            r_mul(a1, a[s1].x, tk1);
            r_mul(b1, a[s1].y, tk2);
            r_add(tk1, tk2, tk3);
            r_mul(tk3, minusone, c1);

            r_mul(a2, a[s3].x, tk1);
            r_mul(b2, a[s3].y, tk2);
            r_add(tk1, tk2, tk3);
            r_mul(tk3, minusone, c2);

            r_mul(a1, b2, tk1);
            r_mul(b1, a2, tk2);
            r_sub(tk1, tk2, det);

            if r_eq(det, zero) then continue;

            r_mul(c1, b2, tk1);
            r_mul(c2, b1, tk2);
            r_sub(tk1, tk2, tk3);
            r_div(tk3, det, inters.x);

            r_mul(a1, c2, tk1);
            r_mul(a2, c1, tk2);
            r_sub(tk1, tk2, tk3);
            r_div(tk3, det, inters.y);

            nw := true;
            for j := 1 to cptr-1 do nw := nw and ((not r_eq(inters.x, a[j].x)) or (not r_eq(inters.y, a[j].y)));
            if nw then
            begin
              a[cptr] := inters;
              inc(cptr);
            end;
          end;
    strt[i+1] := cptr;
  end;

  for i := 1 to cptr-1 do
  begin
    writelong(a[i].x.a); write('/'); writelong(a[i].x.b); write(' ');
    writelong(a[i].y.a); write('/'); writelong(a[i].y.b); writeln;
  end;


  closefile(input); closefile(output);
end.
