program geometry_with_ruler;

{$APPTYPE CONSOLE}
{$r+}

const
  d_max = 10000; //30000;
  d_c = 10000;
  pt_max = 100;

type
  l_num = record
    x: array[0..d_max] of integer;
    l: integer;
    ng: boolean;
  end;
  r_num = record
    a, b: l_num;
  end;
  pt = record
    x, y: r_num;
  end;

var
  x, y, z: l_num;
  zero, minusone: r_num;
  i, j, n, k, cptr, s0, s1, s2, s3: integer;
  xstr, ystr: string;
  a: array[0..pt_max] of pt;
  num, strt: array[0..pt_max] of integer;
  a1, b1, c1, a2, b2, c2, tk1, tk2, tk3, det: r_num;
  inters: pt;
  nw: boolean;
  tempstr: string;


procedure l_pos_add (var apar, bpar, cpar: l_num);
var i, rem: integer;
begin
  i := 1; rem := 0;
  while (i <= apar.l) or (i <= bpar.l) or (rem <> 0) do
  begin
    cpar.x[i] := apar.x[i] + bpar.x[i] + rem;
    rem := cpar.x[i] div d_c;
    cpar.x[i] := cpar.x[i] mod d_c;
    inc(i);
  end;

  cpar.l := i;
  while (cpar.l > 0) and (cpar.x[cpar.l] = 0) do dec(cpar.l);
  cpar.ng := apar.ng;
end;

procedure l_pos_sub (var apar, bpar, cpar: l_num);
var i, rem: integer;
begin
  i := d_max;
  while (i > 0) and (apar.x[i] = bpar.x[i]) do dec(i);

  if i = 0 then exit
  else if apar.x[i] < bpar.x[i] then
  begin
    l_pos_sub(bpar, apar, cpar);
    cpar.ng := true;
    exit;
  end;

  i := 1; rem := 0;
  while (i <= apar.l) or (i <= bpar.l) or (rem <> 0) do
  begin
    cpar.x[i] := apar.x[i] - bpar.x[i] - rem;
    if cpar.x[i] < 0 then
    begin
      rem := 1;
      cpar.x[i] := d_c + cpar.x[i];
    end
    else rem := 0;
    inc(i);
  end;

  cpar.l := i;
  while cpar.x[cpar.l] = 0 do dec(cpar.l);
end;

procedure l_add (var apar, bpar, cpar: l_num);
begin
  fillchar(cpar, sizeof(cpar), 0);
  if (apar.l = 0) and (bpar.l = 0) then exit;

  if (apar.ng = bpar.ng) then l_pos_add(apar, bpar, cpar)
  else if (not apar.ng) and bpar.ng then l_pos_sub(apar, bpar, cpar)
  else l_pos_sub(bpar, apar, cpar);
end;

procedure cpy (var apar, bpar: l_num);
var i: integer;
begin
  for i := 1 to apar.l do bpar.x[i] := apar.x[i];
  bpar.l := apar.l;
end;

procedure l_mult (var apar, bpar, cpar: l_num);
var
  kl, ml: l_num;
  i, j, rem: integer;
begin
  fillchar(cpar, sizeof(cpar), 0);

  if (apar.l = 0) or (bpar.l = 0) then exit;

  for i := 1 to apar.l do
  begin
    fillchar(kl, sizeof(kl), 0);
    kl.l := bpar.l + i - 1;
    for j := 1 to bpar.l do kl.x[j + i - 1] := bpar.x[j];

    j := 1; rem := 0;
    while (j <= kl.l) or (rem <> 0) do
    begin
      kl.x[j] := kl.x[j]*apar.x[i] + rem;
      rem := kl.x[j] div d_c;
      kl.x[j] := kl.x[j] mod d_c;
      inc(j);
    end;
    kl.l := j;

    l_add(cpar, kl, ml);
    cpy(ml, cpar);
  end;

  cpar.ng := apar.ng <> bpar.ng;
end;

procedure r_add (var apar, bpar, cpar: r_num);
var k1, k2: l_num;
begin
  l_mult(apar.b, bpar.b, cpar.b);
  l_mult(apar.a, bpar.b, k1);
  l_mult(apar.b, bpar.a, k2);
  l_add(k1, k2, cpar.a);
end;

procedure r_sub (var apar, bpar, cpar: r_num);
var tl: r_num;
begin
  tl := bpar;
  tl.a.ng := not (tl.a.ng);
  r_add(apar, tl, cpar);
end;

procedure r_mul(var apar, bpar, cpar: r_num);
begin
  l_mult(apar.a, bpar.a, cpar.a);
  l_mult(apar.b, bpar.b, cpar.b);
end;

procedure r_div(var apar, bpar, cpar: r_num);
begin
  l_mult(apar.a, bpar.b, cpar.a);
  l_mult(apar.b, bpar.a, cpar.b);
end;

function l_eq(var apar, bpar: l_num): boolean;
var i: integer;
begin
  result := true; i := 1;
  while result and ((i <= apar.l) or (i <= bpar.l)) do
  begin
    result := result and (apar.x[i]*(ord(apar.ng)*2 - 1) = bpar.x[i]*(ord(bpar.ng)*2 - 1));
    inc(i);
  end;
end;

function r_eq (var apar, bpar: r_num): boolean;
var k1, k2: l_num;
begin
  l_mult(apar.a, bpar.b, k1);
  l_mult(apar.b, bpar.a, k2);
  result := l_eq(k1, k2);
end;

procedure writelong(var apar: l_num);
var i: integer;
begin
  if apar.ng then write('-');
  for i := apar.l downto 1 do
  begin
    if (i <> apar.l) and (apar.x[i] < 1000) then write(0);
    if (i <> apar.l) and (apar.x[i] < 100) then write(0);
    if (i <> apar.l) and (apar.x[i] < 10) then write(0);
    write(apar.x[i]);
  end;
  if apar.l = 0 then write(0);
end;

// Achtung!!!: following procedure does NOT depent on d_c value
procedure getlong(apar: string; var bpar: l_num);
var i, j, k, s, pw: integer;
begin
  fillchar(bpar, sizeof(bpar), 0);
  if apar[1] = '-' then
  begin
    bpar.ng := true;
    apar := copy(apar, 2, length(apar) - 1);
  end;

  i := length(apar); j := 0;
  while i > 0 do 
  begin
    s := 0; inc(j); k := 4; pw := 1;
    while (i > 0) and (k > 0) do 
    begin 
      s := s + pw*(ord(apar[i]) - ord('0')); 
      dec(k); dec(i); pw := pw*10;
    end;
    bpar.x[j] := s;
  end;
  bpar.l := j;
end;

begin
  assignfile (input, 'input.txt'); reset (input);
  assignfile (output, 'output.txt'); rewrite (output);

  minusone.a.l := 1;
  minusone.a.x[1] := 1;
  minusone.a.ng := true;
  minusone.b.l := 1;
  minusone.b.x[1] := 1;
  minusone.b.ng := false;

  zero.b.l := 1;
  zero.b.x[1] := 1;

  readln (n);
  for i := 1 to n do
  begin
    //read (a[i].x.a.x[1], a[i].y.a.x[1]);
    readln(tempstr);

    j := length(tempstr);
    while tempstr[j] = ' ' do dec(j);
    tempstr := copy(tempstr, 1, j); 

    getlong(copy(tempstr, 1, pos(' ', tempstr)-1), a[i].x.a);
    getlong(copy(tempstr, pos(' ', tempstr)+1, length(tempstr) - pos(' ', tempstr)), a[i].y.a);

    a[i].x.b.x[1] := 1; a[i].x.b.l := 1;
    a[i].y.b.x[1] := 1; a[i].y.b.l := 1;
  end;
  cptr := n + 1;
  read(k);

  for i := 1 to k do
  begin
    read(s0, s1, s2, s3);

    r_sub(a[s1].y, a[s0].y, a1);
    r_sub(a[s0].x, a[s1].x, b1);
    r_sub(a[s3].y, a[s2].y, a2);
    r_sub(a[s2].x, a[s3].x, b2);

    r_mul(a1, a[s1].x, tk1);
    r_mul(b1, a[s1].y, tk2);
    r_add(tk1, tk2, c1);

    r_mul(a2, a[s3].x, tk1);
    r_mul(b2, a[s3].y, tk2);
    r_add(tk1, tk2, c2);

    r_mul(a1, b2, tk1);
    r_mul(b1, a2, tk2);
    r_sub(tk1, tk2, det);

    assert(not r_eq(det, zero));

    r_mul(c1, b2, tk1);
    r_mul(c2, b1, tk2);
    r_sub(tk1, tk2, tk3);
    r_div(tk3, det, inters.x);

    r_mul(a1, c2, tk1);
    r_mul(a2, c1, tk2);
    r_sub(tk1, tk2, tk3);
    r_div(tk3, det, inters.y);

    nw := true;
    for j := 1 to cptr-1 do nw := nw and ((not r_eq(inters.x, a[j].x)) or (not r_eq(inters.y, a[j].y)));
    if nw then
    begin
      a[cptr] := inters;
  
      //writelong(a[cptr].x.a); write('/'); writelong(a[cptr].x.b); write(' ');
      //writelong(a[cptr].y.a); write('/'); writelong(a[cptr].y.b); writeln;

      inc(cptr);
    end;

    if r_eq(inters.x, zero) and (r_eq(inters.y, zero)) then 
    begin
//      writeln('Very cool! ', i);
      writeln(i);
      closefile(output);
      halt(0);
    end;
  end;

  writeln(0);
  closefile(input); closefile(output);
end.
